var tbl = document.createElement("table");
var tblThead = document.createElement("thead")
var tblTbody = document.createElement("tbody");
var sloupcu;
var radku = Number.MAX_VALUE;
var ttl;
var vlozeno = 0;
NodeList.prototype.indexOf = [].indexOf;

var appendOnLoad = [];

var tables = {
	
	setTitle: function (title) {
		ttl = document.createElement("p");
		ttl.textContent = title;
	},
	
	createTable: function (id) {
		window.onload = function () {
			document.getElementById(id).appendChild(ttl);
			document.getElementById(id).appendChild(tbl);
			tbl.appendChild(tblThead)
			tbl.appendChild(tblTbody)
		}
	},
	
	setColumnCount: function (n) {
		sloupcu = n;
	},
	
	setHeaderTitles: function (headerTitles) {
		tblThead.innerHTML = "";
		var tr = document.createElement("tr");
		for (var i = 0; i < headerTitles.length; i++) {
			var td = document.createElement("td");
			td.sorted = true;
			td.onmouseover = function () {
				var index = this.parentElement.childNodes.indexOf(this);
				var rows = this.parentElement.parentElement.nextElementSibling.children;
				for (var i = 0; i < rows.length; i++) {
					rows[i].children[index].style.backgroundColor = "lightblue";
				}
				this.style.backgroundColor = "lightblue";
			}
			td.onmouseleave = function () {
				var index = this.parentElement.childNodes.indexOf(this);
				var rows = this.parentElement.parentElement.nextElementSibling.children;
				for (var i = 0; i < rows.length; i++) {
					rows[i].children[index].style.backgroundColor = "transparent";
				}
				this.style.backgroundColor = "transparent";
			}
			td.onclick = function () {
				var index = this.parentElement.childNodes.indexOf(this);
				var rows = this.parentElement.parentElement.nextElementSibling.children;
				for (var j = 0; j < 2; j++) {
					for (var i = 0; i < rows.length - 1; i++) {
						if (this.sorted) {
							if (parseInt(rows[i].children[index].textContent) < parseInt(rows[i + 1].children[index].textContent)) {
								rows[i].parentElement.insertBefore(rows[i + 1], rows[i]);
								i = 0;
							}
						} else {
							if (parseInt(rows[i].children[index].textContent) > parseInt(rows[i + 1].children[index].textContent)) {
								rows[i].parentElement.insertBefore(rows[i + 1], rows[i]);
								i = 0;
							}
						}
					}
				}
				if (this.sorted) {
					this.sorted = false;
				} else {
					this.sorted = true;
				}
			}
			td.textContent = headerTitles[i];
			tr.appendChild(td);
		}
		tblThead.appendChild(tr);
	},

	
	setRowCount: function (n) {
		for (var i = n; i < tblTbody.children.length; i++) {
			tblTbody.removeChild(tblTbody.children[i]);
		}
	},
	
	addRow: function () {
		if (arguments.length != sloupcu) {
			alert("Neplatn data");
		}
		var tr = document.createElement("tr")
		for (var i = 0; i < arguments.length; i++) {
			var td = document.createElement("td");
			td.textContent = arguments[i];
			td.ondblclick = changeCellValue;
				tr.appendChild(td);
		}
		if (vlozeno < radku) {
			tblTbody.appendChild(tr);
			vlozeno++;
		}

	},
	
	addRowFromString: function (rowString) {
		var arguments = rowString.split(";");
		if (arguments.length != sloupcu) {
			alert("Neplatn data");
		}
		var tr = document.createElement("tr")
		for (var i = 0; i < arguments.length; i++) {
			var td = document.createElement("td");
			td.ondblclick = changeCellValue;
			td.textContent = arguments[i];
			tr.appendChild(td);
		}
		if (vlozeno < radku) {
			tblTbody.appendChild(tr);
			vlozeno++;
		}
	},
	
	addRowsJson: function (json) {
		for (var i = 0; i < json.length; i++) {
			var tr = document.createElement("tr")

			if (json[i].length != sloupcu) {
				alert("Neplatn data");
			}
			for (var j = 0; j < json[i].length; j++) {
				var td = document.createElement("td");
				td.textContent = json[i][j];
				td.ondblclick = changeCellValue;
				tr.appendChild(td);
			}
			if (vlozeno < radku) {
				tblTbody.appendChild(tr);
				vlozeno++;
			}
		}
	}
}

function changeCellValue() {
	var inp = document.createElement("input");
	inp.type = "text";
	inp.value = this.textContent;
	this.innerHTML = "";
	this.appendChild(inp);
	inp.onkeydown = function (e) {
		if (e.keyCode == 13) {
			this.textContent = inp.value;
		}
	}.bind(this);
}
